import { BinaryTreeNodeKey, RBColor, RBTreeNodeNested, RBTreeOptions } from '../../types';
import { IBinaryTree } from '../../interfaces';
import { BST, BSTNode } from './bst';
export declare class RBTreeNode<V = any, N extends RBTreeNode<V, N> = RBTreeNodeNested<V>> extends BSTNode<V, N> {
    constructor(key: BinaryTreeNodeKey, val?: V);
    private _color;
    get color(): RBColor;
    set color(value: RBColor);
}
export declare class RBTree<V, N extends RBTreeNode<V, N> = RBTreeNode<V, RBTreeNodeNested<V>>> extends BST<V, N> implements IBinaryTree<V, N> {
    constructor(options?: RBTreeOptions);
    createNode(key: BinaryTreeNodeKey, val?: V): N;
}
